// Chess - Rex 6000 Chess program
//
// Beta release - September x, 2001
//
// Copyright 2001 Chris Harris
//
//						Through Him, with Him, in Him,
//						In the unity of the Holy Spirit,
//						All glory and honor are yours Almighty Father,
//						Forever and ever.
//

//
// This file is part of Chess.
//
// Chess is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.  
//
// Chess is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
// GNU General Public License for more details. 
//
// You should have received a copy of the GNU General Public License 
// along with Chess; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

// Programmer's notes:
//


#include <strings.h>
#include <stdlib.h>	
#include <rex/rex.h>
#include <rex/registry.h>
#include "Chess.h"

// "black" square bmp
const char square[] = {18, 15,
                         0xaa,0xaa,0x80,	// x x x x x x x x x
0,0,0,//                         0xaa,0xaa,0x80,	// x x x x x x x x x
                         0xaa,0xaa,0x80,	// x x x x x x x x x
0,0,0,//                           0xaa,0xaa,0x80,	// x x x x x x x x x
                         0xaa,0xaa,0x80,	// x x x x x x x x x
0,0,0,//                           0xaa,0xaa,0x80,	// x x x x x x x x x
                         0xaa,0xaa,0x80,	// x x x x x x x x x
0,0,0,//                           0xaa,0xaa,0x80,	// x x x x x x x x x
                         0xaa,0xaa,0x80,	// x x x x x x x x x
0,0,0,//                           0xaa,0xaa,0x80,	// x x x x x x x x x
                         0xaa,0xaa,0x80,	// x x x x x x x x x
0,0,0,//                           0xaa,0xaa,0x80,	// x x x x x x x x x
                         0xaa,0xaa,0x80,	// x x x x x x x x x
0,0,0,//                           0xaa,0xaa,0x80,	// x x x x x x x x x
                         0xaa,0xaa,0x80 };
 
const char highlight[] = {18, 15,
0xff,0xff,0x80,
0xff,0xff,0xc0,
0xd5,0x55,0x80,
0xd5,0x55,0x80,
0xd5,0x55,0x80,
0xd5,0x55,0x80,
0xd5,0x55,0x80,
0xd5,0x55,0x80,
0xd5,0x55,0x80,
0xd5,0x55,0x80,
0xd5,0x55,0x80,
0xd5,0x55,0x80,
0xd5,0x55,0x80,
0xff,0xff,0x80,
0xff,0xff,0x80};
/*                         0xaa,0xaa,0x80,	// x x x x x x x x x
0x55,0x55,0x40,//                         0xaa,0xaa,0x80,	// x x x x x x x x x
                         0xaa,0xaa,0x80,	// x x x x x x x x x
0x55,0x55,0x40,//                            0xaa,0xaa,0x80,	// x x x x x x x x x
                         0xaa,0xaa,0x80,	// x x x x x x x x x
0x55,0x55,0x40,//                            0xaa,0xaa,0x80,	// x x x x x x x x x
                         0xaa,0xaa,0x80,	// x x x x x x x x x
0x55,0x55,0x40,//                            0xaa,0xaa,0x80,	// x x x x x x x x x
                         0xaa,0xaa,0x80,	// x x x x x x x x x
0x55,0x55,0x40,//                            0xaa,0xaa,0x80,	// x x x x x x x x x
                         0xaa,0xaa,0x80,	// x x x x x x x x x
0x55,0x55,0x40,//                            0xaa,0xaa,0x80,	// x x x x x x x x x
                         0xaa,0xaa,0x80,	// x x x x x x x x x
0x55,0x55,0x40,//                            0xaa,0xaa,0x80,	// x x x x x x x x x
                         0xaa,0xaa,0x80 };
*/
const char whitesquare[] = {18, 15, 
0,0,0,
0,0,0,
0,0,0,
0,0,0,
0,0,0,
0,0,0,
0,0,0,
0,0,0,
0,0,0,
0,0,0,
0,0,0,
0,0,0,
0,0,0,
0,0,0,
0,0,0 };
/*
                         0x44,0x44,0x40,	// x   x   x   x   x
                         0x44,0x44,0x40,	// x   x   x   x   x
                         0x44,0x44,0x40,	// x   x   x   x   x
                         0x44,0x44,0x40,	// x   x   x   x   x
                         0x44,0x44,0x40,	// x   x   x   x   x
                         0x44,0x44,0x40,	// x   x   x   x   x
                         0x44,0x44,0x40,	// x   x   x   x   x
                         0x44,0x44,0x40,	// x   x   x   x   x
                         0x44,0x44,0x40,	// x   x   x   x   x
                         0x44,0x44,0x40,	// x   x   x   x   x
                         0x44,0x44,0x40,	// x   x   x   x   x
                         0x44,0x44,0x40,	// x   x   x   x   x
                         0x44,0x44,0x40,	// x   x   x   x   x
                         0x44,0x44,0x40,	// x   x   x   x   x
                         0x44,0x44,0x40};	// x   x   x   x   x
*/
// White pawn, knight, rook, bishop, queen, king
// black ""
// = 12 pieces

// BOLD char set in log. pg 0x75:
// 8000: 0x00-0x1f UNUSED, except for 0x0a
// 8018: 0x01
// 8030: 0x02
// ...
// 8180: 0x10
// ...
// 8300: 0x20 USED, of course
// ...
// 8600: 0x40 USED, of course
// ...
int main()
{
	int ret, ret2;
	int p;
POINT pt;
int x,y;

	if (!Load())
		Clear();

	Draw();

	do {
		ret = Select();
		if (ret == NEW_BUTTON) {
			Clear();
			Draw();
		}
		else if (ret == SAVE_BUTTON) {
			Save();
		}
		else if (ret == EXIT_BUTTON) {
			ret = -1;
		}
		else {
			pt.PointX = 255;
			DsTouchDataGet(pt);
			if (pt.PointX != 255) {
				x= pt.PointX;
				y= pt.PointY;
				if (x<145) {
					x=x/18+1;
					y=y/15+1;
					ret = (((y-1)*8) + (x-1)) + 10;
				}
				else ret = 0;
			}
			else ret = 0;
		}

		if (ret >= 10 && ret < 74) {
//			DiagMsg("Select1", ret-10);
			if (Table[ret-10]) {
				Hilite(ret-10);

				ret2 = Select();
				pt.PointX = 255;
				DsTouchDataGet(pt);
				if (pt.PointX != 255) {
					x= pt.PointX;
					y= pt.PointY;
					if (x<145) {
						x=x/18+1;
						y=y/15+1;
						ret2 = (((y-1)*8) + (x-1)) + 10;
					}
					else ret2 = 0;
				}
				else ret2 = 0;

				if (ret2 >= 10 && ret2 < 74) {
	//				DiagMsg("Select2", ret2-10);
					p = Blank(ret-10);
					Move(p, ret2-10);
				}
			}
		}
	} while (ret > 0);

}

void Clear()
{
	memcpy(Table, NEWGAME, 64);	
}


int Blank(int n)
{
	int x, y;
	int i, j;
	int ret;

	j = n/8;
	i = n - (j*8);
	x = i*18;
	y = j*15;
	if ( (i ^ j) & 1)
		DsDisplayBitmapDraw(x, y, square, 0);
	else
		DsDisplayBitmapDraw(x, y, whitesquare, 0);

	ret = Table[n];
	Table[n] = 0;
	return ret;
}

void Move(int piece, int n)
{
	int x, y;
	int i, j;
	int ret;

	j = n/8;
	i = n - (j*8);
	x = i*18;
	y = j*15;
	if ( (i ^ j) & 1)
		DsDisplayBitmapDraw(x, y, square, 0);
	else
		DsDisplayBitmapDraw(x, y, whitesquare, 0);

	Table[n] = piece;
	DrawPiece(piece, x, y);
}


void Hilite(int n)
{
	int x, y;
	int i, j;
	int ret;
	int piece;

	j = n/8;
	i = n - (j*8);
	x = i*18;
	y = j*15;
	DsDisplayBitmapDraw(x, y, highlight, 0);

	piece = Table[n];
//DiagMsg("Hilite", n);
//DiagMsg("piece",piece);
//DiagMsg("x",x);
//DiagMsg("y",y);
	DrawPiece(piece, x, y);
}


void Draw()
{
	int i, j;
	int x, y;
	int n;
	int p;
	int a, aRev, atemp;
	int piece, color;
	int event;

	DsEventClear();
	DsClearScreen();

//	event = 10;
	for (i = 0, y = 0, n = 0; i < 8; i++, y+=15) {
		for (j = 0, x=0; j < 8; j++, x+=18) {
//			DsEventAdd(x, y, x+18, y+15, event++, 1);
			if ( (i ^ j) & 1)
				DsDisplayBitmapDraw(x, y, square, 0);

			p = Table[n++];
			if (p)
				DrawPiece(p, x, y);
		}
	}
//	DsDisplayBlock(0, 0, 145, 120,0);
	DsEventAdd(0, 0, 145, 120, 10, 1);

	DsDialogTextButton(180,  0, 40, 18, EXIT_BUTTON, "Exit");
	DsDialogTextButton(180, 20, 40, 18, NEW_BUTTON, "New");
	DsDialogTextButton(180, 40, 40, 18, SAVE_BUTTON, "Save");
}

void DrawPiece(int p, int x, int y)
{
	int color, piece;
	int a, aRev, aTemp;

	color = p & 0xf0;
	piece = p & 0x0f;
	a = (int) WhitePiece[piece-1];
	aRev = (int) BlackPiece[piece-1];
	if (color) {
		aTemp = a;
		a = aRev;
		aRev = aTemp;
	}
	DsPrintf(x, y+1, 17, (char *) &aRev);
	DsPrintf(x, y+1, 16, (char *) &a);	
}


// Select() - waits for a user key press or button touch, and returns it
int Select()
{
	int stop = 0;
	int ret = 0;
	MSG msg;

	/*Wait for event*/

	while (!stop) {
	  DsEventMessageGet(&msg);
	  switch(msg.message) {

		case MSG_DS_KEY_DOWN:
			// Do not accept keypress until it gets to state "C" (??)
			switch (msg.sCode) {
				case KEY_TOP_C:
				case KEY_BACK_C:
				case KEY_ENTER_C:
				case KEY_UP_C:
				case KEY_DOWN_C:
					stop=1;
					ret = -msg.sCode;
					break;
			}
			break;


		// Button touched (on touchscreen): return it.
		case MSG_DS_COMMAND:
			ret = msg.bCode;
			stop = 1;
			break;

		case MSG_DS_CLOSE: 
			ret = 0;
			stop = 1;
			break;
	  }
	}
	return ret;
}

int Load()
{
	int ret;

	ret = reg_database_create();
	if (ret < 0) {
		if (ret == REG_ERR_NO_DB)
			return FALSE;
		else
			CriticalError(10, ret);
	}
	ret = reg_read_binary(REX_CHESS_REG_KEY, Table, 64);
	if (ret < 0) {
		if (ret == REG_ERR_NOT_FOUND)
			return FALSE;
		else
			CriticalError(11, ret);
	}
	else if (ret != 64)
		CriticalError(12, ret);
	return TRUE;
}

void Save()
{
	int ret;

	ret = reg_database_create();
	if (ret < 0)
		CriticalError(13, ret);

	ret = reg_write_binary(REX_CHESS_REG_KEY, Table, 64);
	if (ret < 0)
		CriticalError(14, ret);
}





///////////////////////////////////////////////////////////////////////////////
//
// Misc. functions:
//
///////////////////////////////////////////////////////////////////////////////


// Convert integer to 4 digit hex string, NIL terminated
void itoh4(char *str, int n)
{
	itoh2(str, n >> 8);
	itoh2(&str[2], n & 0xff);
}


// Convert integer to 2 digit hex string, NIL terminated
void itoh2(char *str, int n)
{
	str[0] = HexChar[(n>>4)&0x0f];
    str[1] = HexChar[n & 0x0f];
	str[2] = 0;
}


// Display a warning/error message with a numeric code,
// wait for user keypress, and continue
void DiagMsg(char *msg, int code)
{
	char str[50];
	int i;

	DsClearScreen();
	DsEventClear();
	strcpy(str, msg);
	i = strlen(str);
	str[i++] = ':';
	str[i++] = ' ';
	itoh4(&str[i], code);

	DsPrintf(10,40,16,str);
	DsPrintf(20,60,16,"Press any key to continue");
	Select();
}


// Fatal error has occurred: display error code message
// (and optional error return), wait for keypress, then EXIT
void CriticalError(int err, int code)
{
//	char *str = "Error #    :";  // this didn't work - string is not really on stack?
	char str[13];

	strcpy(str,  "Error #    :");
	itoh4(&str[7], err);
	DiagMsg(str, code);
	DsAddinTerminate();
}


