// Chess.h - definitions and global variables used in "Adder" program
//
// Copyright 2001 Chris Harris
//
// This file is part of Adder.
//
// Adder is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.  
//
// Adder is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
// GNU General Public License for more details. 
//
// You should have received a copy of the GNU General Public License 
// along with Adder; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

//////////////////////////////////////////////////////////////////////////////////////

// Useful typedef's:

typedef unsigned char	BYTE;
typedef unsigned int	WORD;

#define TRUE 1
#define FALSE 0

//////////////////////////////////////////////////////////////////////////////////////

// Constants:
/*
int NewGame[] = {
0x0117, 0x0127, 0x0137, 0x0147, 0x0157, 0x0167, 0x0177, 0x0187, // white pawns
0x0218, 0x0288, // white rooks
0x0328, 0x0378, // white knights
0x0438, 0x0468, // white bishops
0x0548, 0x0658, // white queen, king
0x1112, 0x1122, 0x1132, 0x1142, 0x1152, 0x1162, 0x1172, 0x1182, // black pawns
0x1211, 0x1281, // black rooks
0x1321, 0x1371, // black knights
0x1431, 0x1461, // black bishops
0x1541, 0x1651  // black queen, king
};*/

BYTE NEWGAME[] = {
0x12, 0x13, 0x14, 0x15, 0x16, 0x14, 0x13, 0x12,
0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01,
0x02, 0x03, 0x04, 0x05, 0x06, 0x04, 0x03, 0x02 };

BYTE Table[64];

#define PAWN	1
#define ROOK	2
#define KNIGHT	3
#define BISHOP	4
#define QUEEN	5
#define KING	6

BYTE WhitePiece[] = { 0x02, 0x06, 0x0c, 0x10, 0x18, 0x14 };
BYTE BlackPiece[] = { 0x04, 0x08, 0x0e, 0x12, 0x1a, 0x16 };
//BYTE WhitePiece[] = { 'p', 'r', 'n', 'b', 'q', 'k' };
//BYTE BlackPiece[] = { 'P', 'R', 'N', 'B', 'Q', 'K' };

char *REX_CHESS_REG_KEY = "RexChess01Game";

#define EXIT_BUTTON 7
#define NEW_BUTTON 8
#define SAVE_BUTTON 9

//////////////////////////////////////////////////////////////////////////////////////

// Global variables

int DbHandle;


// Hex-ASCII lookup table
char *HexChar = "0123456789ABCDEF";


//////////////////////////////////////////////////////////////////////////////////////

// Function prototypes:

void DrawBoard();
void Draw();
void StartNewGame();
void DrawPiece(int p, int x, int y);
int Blank(int n);
void Move(int p, int n);
void Hilite(int n);

int Load();
void Save();
void Clear();

void CriticalError(int err, int code);
void DiagMsg(char *msg, int code);
void itoh4(char *str, int n);
void itoh2(char *str, int n);

