// ChessFont - Rex 6000 Chess Font Installation program
//
// Beta release - January 23, 2002
//
// Copyright 2002 Chris Harris
//
//						Through Him, with Him, in Him,
//						In the unity of the Holy Spirit,
//						All glory and honor are yours Almighty Father,
//						Forever and ever.
//

//
// This file is part of Chess.
//
// Chess is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.  
//
// Chess is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
// GNU General Public License for more details. 
//
// You should have received a copy of the GNU General Public License 
// along with Chess; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

// Programmer's notes:
//


#include <strings.h>
#include <stdlib.h>
#include <rex/rex.h>
#include "ChessFnt.h"

const char wpawn[] = {16, 13,
0x00,0x00,
0x00,0x00,
0x00,0x00,
0x01,0xc0,	//   xxx
0x02,0x20,	//  x   x
0x02,0x20,	//  x   x
0x01,0x40,	//   x x
0x02,0x20,	//  x   x
0x04,0x10,	// x     x
0x04,0x10,	// x     x
0x02,0x20,	//  x   x
0x04,0x10,	// x     x
0x0f,0xf8	//xxxxxxxxx
};
//0x08,0x08,	//x       x

const char bpawn[] = {16, 13,
0x00,0x00,
0x00,0x00,
0x00,0x00,
0x01,0xc0,	//   xxx
0x03,0xe0,	//  x   x
0x03,0xe0,	//  x   x
0x01,0xc0,	//   x x
0x03,0xe0,	//  x   x
0x07,0xf0,	// x     x
0x07,0xf0,	// x     x
0x03,0xe0,	//  x   x
0x07,0xf0,	// x     x
0x0f,0xf8	//xxxxxxxxx
};
//0x0f,0xf8,	//x       x

/* "a pawn" mask, to clear background:
const char apawn[] = {16, 11,
0x01,0xc0,
0x03,0xe0,	//   xxx
0x07,0xf0,	//  x   x
0x07,0xf0,	//  x   x
0x07,0xf0,	//   x x
0x07,0xf0,	//  x   x
0x0f,0xf8,	// x     x
0x0f,0xf8,	// x     x
0x0f,0xf8,	//  x   x
0x0f,0xf8,	// x     x
0x1f,0xfc	//xxxxxxxxx
}; */

const char wrook[] = {16, 13,
0,0,
0,0,
0x0d,0xd8,	// xx xxx xx
0x0a,0x28,	// x x   x x
0x08,0x08,	// x       x
0x0e,0x38,	// xxx   xxx
0x02,0x20,	//   x   x
0x02,0x20,	//   x   x
0x02,0x20,	//   x   x
0x02,0x20,	//   x   x
0x06,0x30,	//  xx   xx
0x18,0x0c,	//xx       xx
0x1f,0xfc	//xxxxxxxxxxx
};

const char brook[] = {16, 13,
0,0,
0,0,
0x0d,0xd8,	// xx xxx xx
0x0f,0xf8,	// xxxxxxxxx
0x0f,0xf8,	// xxxxxxxxx
0x0f,0xf8,	// xxxxxxxxx
0x03,0xe0,	//   xxxxx
0x03,0xe0,	//   xxxxx
0x03,0xe0,	//   xxxxx
0x03,0xe0,	//   xxxxx
0x07,0xf0,	//  xxxxxxx
0x1f,0xfc,	//xxxxxxxxxxx
0x1f,0xfc	//xxxxxxxxxxx
};

/* "a rook" mask, to clear background
const char arook[] = {16, 11,
0x0f,0xf8,
0x1f,0xfc,	// xx xxx xx
0x1f,0xfc,	// xxxxxxxxx
0x1f,0xfc,	// xxxxxxxxx
0x1f,0xfc,	// xxxxxxxxx
0x1f,0xfc,	//   xxxxx
0x1f,0xfc,	//   xxxxx
0x1f,0xfc,	//   xxxxx
0x1f,0xfc,	//  xxxxxxx
0x3f,0xfe,	//xxxxxxxxxxx
0x3f,0xfe	//xxxxxxxxxxx
}; */

const char wbishop[] = {16, 13,
0x01,0x00,	//     x
0x02,0x80,	//    x x
0x04,0x40,	//   x   x
0x09,0x20,	//  x  x  x
0x13,0x90,	// x  xxx  x
0x11,0x10,	// x   x   x
0x11,0x10,	// x   x   x
0x10,0x10,	// x       x
0x10,0x10,	// x       x
0x08,0x20,	//  x     x
0x0c,0x60,	//  xx   xx
0x30,0x18,	//xx       xx
0x3f,0xf8	//xxxxxxxxxxx
};


const char bbishop[] = {16, 13,
0x01,0x00,	//     x
0x03,0x80,	//    x x 
0x07,0xc0,	//   x   x
0x0e,0xe0,	//  x  x  x
0x1c,0x70,	// x  xxx  x
0x1e,0xf0,	// x   x   x
0x1e,0xf0,	// x   x   x
0x1f,0xf0,	// x       x
0x1f,0xf0,	// x       x
0x0f,0xe0,	//  x     x
0x0f,0xe0,	//  xx   xx
0x3f,0xf8,	//xx       xx
0x3f,0xf8	//xxxxxxxxxxx
};



const char wknight[] = {16, 13,
0x00,0x80,	//        x
0x03,0x60,	//      xx xx
0x0c,0x30,	//    xx    xx
0x08,0x18,	//    x      xx
0x14,0x0c,	//   x x      xx
0x20,0x84,	//  x     x    x
0x41,0x44,	// x     x x   x
0x44,0x84,	// x   x  x    x
0x39,0x04,	//  xxx  x     x
0x01,0x08,	//       x    x
0x06,0x08,	//     xx     x
0x18,0x0c,	//   xx       xx
0x1f,0xfc	//   xxxxxxxxxxx
};

const char bknight[] = {16, 13,
0x00,0x80,	//        x
0x03,0xe0,	//      xx xx
0x0f,0xf0,	//    xx    xx
0x0f,0xf8,	//    x      xx
0x1b,0xfc,	//   x x      xx
0x3f,0xfc,	//  x     x    x
0x7f,0x7c,	// x     x x   x
0x7c,0xfc,	// x   x  x    x
0x39,0xfc,	//  xxx  x     x
0x01,0xf8,	//       x    x
0x07,0xf8,	//     xx     x
0x1f,0xfc,	//   xx       xx
0x1f,0xfc	//   xxxxxxxxxxx
};

/* tall king:
const char wking[] = {16, 13,
0x01,0x00,	//
0x03,0x80,	//
0x09,0x20,	//
0x07,0xc0,	//
0x02,0x80,	//
0x02,0x80,	//
0x0f,0xe0,	//
0x04,0x40,	//
0x02,0x80,	//
0x02,0x80,	//
0x0c,0x60,	//
0x10,0x10,	//x       x
0x1f,0xf0	//xxxxxxxxx
};
*/
const char wking[] = {16, 13,
0x00,0x00,	//
0x01,0x00,	//       x
0x7a,0xbc,	// xxxx x x xxxx
0xc5,0x46,	//xx   x x x   xx
0x83,0x82,	//x     xxx     x
0x81,0x02,	//x      x      x
0x81,0x02,	//x      x      x
0x41,0x04,	// x     x     x
0x41,0x04,	// x     x     x
0x31,0x18,	//  xx   x   xx
0x3f,0xf8,	//  xxxxxxxxxxx
0x20,0x08,	//  x  x   x  x
0x3f,0xf8	//  xxxxxxxxxxx
};

const char bking[] = {16, 13,
0x00,0x00,	//
0x01,0x00,	//       x
0x7b,0xbc,	// xxxx x x xxxx
0xfd,0x7e,	//xx   x x x   xx
0xff,0xfe,	//x     xxx     x
0xfe,0xfe,	//x      x      x
0xfe,0xfe,	//x      x      x
0x7e,0xfc,	// x     x     x
0x7e,0xfc,	// x     x     x
0x3e,0xf8,	//  xx   x   xx
0x3f,0xf8,	//  xxxxxxxxxxx
0x3f,0xf8,	//  x  x   x  x
0x3f,0xf8	//  xxxxxxxxxxx
};


const char wqueen[] = {16, 13,
0x00,0x00,	//
0x01,0x00,	//       x
0x11,0x88,	//   x   xx   x
0x99,0x99,	//x  xx  xx  xx  x
0xd9,0x9b,	//xx xx  xx  xx xx
0xcd,0xb3,	//xx  xx xx xx  xx
0x6d,0xb6,	// xx xx xx xx xx
0x6d,0xb6,	// xx xx xx xx xx
0x3f,0xfc,	//  xxxxxxxxxxxx
0x24,0x24,	//  x  x    x  x
0x2a,0x54,	//  x x x  x x x
0x24,0x24,	//  x  x    x  x
0x3f,0xfc	//  xxxxxxxxxxxx
};


const char bqueen[] = {16, 13,
0x00,0x00,	//
0x01,0x00,	//       x
0x11,0x88,	//   x   x   x
0x99,0x99,	//x  x  x x  x  x
0xd9,0x9b,	// x  x x x x  x
0xcd,0xb3,	// x  x x x x  x
0x6d,0xb6,	// x  x x x x  x
0x6d,0xb6,	// xxxxxxxxxxxxx
0x3f,0xfc,	//  x         x
0x3b,0xdc,	//  x         x
0x35,0xac,	//  xxxxxxxxxxx
0x3b,0xdc,	//  x         x
0x3f,0xfc	//  xxxxxxxxxxx
};


const char nullchar[] = {2, 11,
0x00,0x00,	//
0x00,0x00,	//
0x00,0x00,	//
0x00,0x00,	//
0x00,0x00,	//
0x00,0x00,	//
0x00,0x00,	//
0x00,0x00,	//
0x00,0x00,	//
0x00,0x00,	// 
0x00,0x00	// 
};

const char char0a[] = {11, 11,
0x00,0x00,	//
0x00,0x00,	//
0x08,0x00,	//
0x08,0x00,	//
0x08,0x00,	//
0x08,0x00,	//
0x28,0x00,	//
0x68,0x00,	//
0xf8,0x00,	//
0x60,0x00,	// 
0x20,0x00	// 
};

// White pawn, knight, rook, bishop, queen, king
// black ""
// = 12 pieces
// + "outline" piece = 18 pieces;
// 6 are 11 pixel high = 6 font slots
// 12 are 13 pixel high = 24 font slots

// BOLD char set in log. pg 0x75:
// 8000: 0x00-0x1f UNUSED, except for 0x0a
// 8018: 0x01
// 8030: 0x02
// ...
// 8180: 0x10
// ...
// 8300: 0x20 USED, of course
// ...
// 8600: 0x40 USED, of course
// ...


int main()
{
	int page, sector;
	int i, source;
	int a;
	char str[40];
	int ret;

	ret=asm("call\tgetpage");
	if (ret < 0x7c || ret > 0x83) {
		DiagMsg("Do not run this addin in Adder", ret);
		return;
	}


	if (!ConfirmDialog("Install chess font?"))
		return;
	if (!ConfirmDialog("Are your Rex batteries GOOD?"))
		return;

	DsDisplayWaitIconDraw(1);
	page = 0x79;	

#asm
	di
#endasm

	if (!IsSectorBlank(SPARE_SECTOR)) {
		EraseSector(SPARE_SECTOR);
	}

	sector = 0x78;

	// Copy all of specified page's 64KB sector to spare 64KB sector,
	// EXCEPT for specified page:  i.e., leave page being deleted BLANK.

	for (i = 0; i < 8; i++) {
		source = sector+i;
		if (source != page) {	// copy all pages EXCEPT our target page
			CopyFlashPage(source, SPARE_SECTOR+i);
		}
	}

// Page 75:


//for (i = 0x8000; i < 0x8180; i++) {
// a = Peek(0x75+4, i) & 0xff;
// FlashByte(i, 0x31 + (a << 8));
//}

FlashFontChar(0x00, 0x31, nullchar);

FlashFontChar(0x02, 0x31, wpawn);
FlashFontChar(0x04, 0x31, bpawn);
//FlashFontChar(0x03, 0x31, apawn);

FlashFontChar(0x06, 0x31, wrook);
FlashFontChar(0x08, 0x31, brook);

FlashFontChar(0x0c, 0x31, wknight);
FlashFontChar(0x0e, 0x31, bknight);

FlashFontChar(0x0a, 0x31, char0a);
//FlashFontChar(0x0b, 0x31, arook);

FlashFontChar(0x10, 0x31, wbishop);
FlashFontChar(0x12, 0x31, bbishop);

FlashFontChar(0x14, 0x31, wking);
FlashFontChar(0x16, 0x31, bking);

FlashFontChar(0x18, 0x31, wqueen);
FlashFontChar(0x1a, 0x31, bqueen); 

//Piecemeal copy logical pg40 (phys 44)
//to physical pg34

for (i = 0x8300; i < 0xa000; i++) {
	a = Peek(0x75+4, i) & 0xff;
 FlashByte(i, 0x31 + (a << 8));
}

	EraseSector(sector);


	// Re-flash specified page's 64KB sector by copying FROM spare 64KB sector,

	for (i = 0; i < 8; i++) {
		CopyFlashPage(SPARE_SECTOR+i, sector+i);
	}

	if (!IsSectorBlank(SPARE_SECTOR)) {
//		DiagMsg("Erasing spare sector for next time",SPARE_SECTOR);
		EraseSector(SPARE_SECTOR);
	}

#asm
	ei
#endasm

	DsClearScreen();
	strcpy(str, "Chess font installation complete.");
	DsPrintf(0, 40, 16, str);
	strcpy(str, "The ChessFont addin may now be deleted.");
	DsPrintf(0, 60, 16, str);

	DsEventAdd(0, 0, 240, 120, 10, 1);
	Select();
}

#asm
.getpage
	in	a,($01)
	ld	l,a
	in	a,($02)
	ld	h,a
	ret
#endasm

void FlashFontChar(int n, int page, BYTE *data)
{
	int i, j;
	int x, y;
	int addr;
	int count;

	addr = 0x8000 + (n * 0x18);
	x = data[0];
	y = data[1];
	count = (y * 2) + 2;

	for (i = addr, j = 0; i < (addr + count); i++, j++)
		FlashByte(i, page + (data[j] << 8));
}


// Select() - waits for a user key press or button touch, and returns it
int Select()
{
	int stop = 0;
	int ret = 0;
	MSG msg;

	/*Wait for event*/

	while (!stop) {
	  DsEventMessageGet(&msg);
	  switch(msg.message) {

		case MSG_DS_KEY_DOWN:
			// Do not accept keypress until it gets to state "C" (??)
			switch (msg.sCode) {
				case KEY_TOP_C:
				case KEY_BACK_C:
				case KEY_ENTER_C:
				case KEY_UP_C:
				case KEY_DOWN_C:
					stop=1;
					ret = -msg.sCode;
					break;
			}
			break;


		// Button touched (on touchscreen): return it.
		case MSG_DS_COMMAND:
			ret = msg.bCode;
			stop = 1;
			break;

		case MSG_DS_CLOSE: 
			ret = 0;
			stop = 1;
			break;
	  }
	}
	return ret;
}





///////////////////////////////////////////////////////////////////////////////
//
// Misc. functions:
//
///////////////////////////////////////////////////////////////////////////////


// Convert integer to 4 digit hex string, NIL terminated
void itoh4(char *str, int n)
{
	itoh2(str, n >> 8);
	itoh2(&str[2], n & 0xff);
}


// Convert integer to 2 digit hex string, NIL terminated
void itoh2(char *str, int n)
{
	str[0] = HexChar[(n>>4)&0x0f];
    str[1] = HexChar[n & 0x0f];
	str[2] = 0;
}


// Display a warning/error message with a numeric code,
// wait for user keypress, and continue
void DiagMsg(char *msg, int code)
{
	char str[50];
	int i;

	DsClearScreen();
	DsEventClear();
	strcpy(str, msg);
	i = strlen(str);
	str[i++] = ':';
	str[i++] = ' ';
	itoh4(&str[i], code);

	DsPrintf(10,40,16,str);
	DsPrintf(20,60,16,"Press any key to continue");
	Select();
}


// Fatal error has occurred: display error code message
// (and optional error return), wait for keypress, then EXIT
void CriticalError(int err, int code)
{
//	char *str = "Error #    :";  // this didn't work - string is not really on stack?
	char str[13];

	strcpy(str,  "Error #    :");
	itoh4(&str[7], err);
	DiagMsg(str, code);
	DsAddinTerminate();
}

// ConfirmDialog - displays provided string as a one-line question, 
// and provides Yes and No buttons for user confirmation.  
// Returns:  True = Yes,  False = No 
int ConfirmDialog(char *str)
{
	DsEventClear();
	DsClearScreen();
	// would be nice to center string, approximately.  but for now:
	DsPrintf(20,50,16, str);

	DsDialogTextButton(COLUMN1, 90, 
		BUTTONWIDTH, BUTTONHEIGHT, 
		YES_BUTTON, "Yes");

	DsDialogTextButton(COLUMN2, 90, 
		BUTTONWIDTH, BUTTONHEIGHT, 
		NO_BUTTON, "No");

	// Wait for user confirmation
	if (Select() == YES_BUTTON)
		return TRUE;

	return FALSE;
}




