// ChessFnt.h - definitions and global variables used in "Adder" program
//
// Copyright 2001 Chris Harris
//
// This file is part of Adder.
//
// Adder is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.  
//
// Adder is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
// GNU General Public License for more details. 
//
// You should have received a copy of the GNU General Public License 
// along with Adder; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

//////////////////////////////////////////////////////////////////////////////////////

// Useful typedef's:

typedef unsigned char	BYTE;
typedef unsigned int	WORD;

#define TRUE 1
#define FALSE 0

//////////////////////////////////////////////////////////////////////////////////////

// Constants:


#define SPARE_SECTOR 0x30	// 64KB empty flash sector, used for temporary
							// storage of other pages when erasing another sector.



#define BUTTONHEIGHT 18
#define BUTTONWIDTH 70

#define COLUMN1 0
#define COLUMN2	85
#define COLUMN3 170



#define YES_BUTTON	20 
#define NO_BUTTON	21

//////////////////////////////////////////////////////////////////////////////////////

// Global variables

int DbHandle;


// Hex-ASCII lookup table
char *HexChar = "0123456789ABCDEF";


//////////////////////////////////////////////////////////////////////////////////////

// Function prototypes:

void FlashFontChar(int n, int page, BYTE *data);

void CriticalError(int err, int code);
void DiagMsg(char *msg, int code);
void itoh4(char *str, int n);
void itoh2(char *str, int n);

// Assembly-language functions in Flash.c:
extern int   IsSectorBlank(int);
extern int   IsPageBlank(int);
extern void  EraseSector(int);
extern int   CopyFlashPage(int, int);
extern void  FarJump(int, int);
extern int   Peek(int, int);
